#include <avr/io.h>
#include <avr/delay.h>
#define DELAY(VALUE) _delay_loop_2(VALUE)
#define DELAYMS(VALUE) DELAY(VALUE*250)

#define SETDATA(VALUE) PORTB=(PORTB & 0x7F)|((VALUE & 1)<<7)
#define SETMAIN(VALUE) PORTD=((VALUE << 1) & 0xE0)|(VALUE & 0x0F)

#define SETRCK PORTB|=0x40;
#define CLEARRCK PORTB&=0xFF-0x40;
#define DORCK SETRCK; CLEARRCK;

#define SETSCK PORTB|=1;
#define CLEARSCK PORTB&=254;
#define DOSCK SETSCK; CLEARSCK;

#define SETLIGHT PORTC|=4
#define CLEARLIGHT PORTC&=(0xFF-4)

#define BUTTON ((PIND >> 4) & 1)

#define BUTTA ((~PINC) & 1)
#define BUTTB ((~PINC >> 1) & 1)
#define BUTTC ((~PINC >> 5) & 1)
signed char arr[9];
signed char nums[10]={0,40,93,109,43,103,119,44,0x7F,111};
signed char nums2[10]={0,65,59,107,77,110,126,67,127,111};
signed char nextpos,currtest,playernum,vil;
void init(void){
	 DDRC=4; // pb2 kimenet egoknek
	 PORTC=0x23; //pc0,pc1,pc5 = pullup be (gombok)
     DDRD=0xEF; // minden kimenet kiveve pb4 (button)
     DDRB=0xFF; //minden kimenet
}
int main(void){
    int i,j; for (i=0;i<9;i++) arr[i]=0; 
	init(); SETLIGHT;
    nextpos=1; currtest=0;
    playernum=3; vil=1;
	while (1) {
        SETMAIN(nums[playernum]);
		for (i=8; i>=0;i--) {
				for (j=6;j>=0;j--) {
				    SETDATA((~nums2[arr[i]]) >> j);
                    DOSCK; 
                }				
			if (currtest==i) {SETDATA(1);} else {SETDATA(0);}
			DOSCK;
        }
        DORCK;
        if (vil==arr[currtest]) {CLEARLIGHT;} else {SETLIGHT;}
        if ((BUTTON)&&(arr[currtest]==0)) { 
		    arr[currtest]=nextpos; 
			if (vil==0) vil=1; 
			nextpos++;
		}
        currtest++;
		if (currtest>=playernum) currtest=0;
		if (BUTTC) {
		    playernum++;
			if (playernum==10) playernum=2;
			while (BUTTC) {DELAYMS(10);}
			DELAYMS(10);
		}
		if (BUTTB) {
		    vil++;
			while (BUTTB) {DELAYMS(10);}
			DELAYMS(10);
		}
		if (BUTTA) {
		   for (i=0;i<9;i++) arr[i]=0;
		   vil=1; currtest=0;
		   nextpos=1;
		}
    }	
	return 0;
}

